"use strict";
{
	const C3 = self.C3;

	C3.Plugins.skymen_ExperimentalTextFix.Type = class skymen_ExperimentalTextFixType extends C3.SDKTypeBase
	{
		constructor(objectClass)
		{
			super(objectClass);
		}
		
		Release()
		{
			super.Release();
		}
		
		OnCreate()
		{	
		}
	};
	
	let oldClass = C3.Gfx.RendererText;
	
	const EXTRA_LINE_HEIGHT = 4;
	function fillOrStrokeText(ctx, isStroke, text, x, y, maxWidth) {
	  if (isStroke)
	    if (C3.Platform.BrowserEngine === "Gecko")
	      ctx.strokeText(text, x, y, maxWidth);
	    else ctx.strokeText(text, x, y);
	  else if (C3.Platform.BrowserEngine === "Gecko")
	    ctx.fillText(text, x, y, maxWidth);
	  else ctx.fillText(text, x, y);
	}
	function fillOrStrokeRect(ctx, isStroke, x, y, w, h) {
	  if (isStroke) ctx.strokeRect(x, y, w, h);
	  else ctx.fillRect(x, y, w, h);
	}
	
	C3.Gfx.RendererText = class extends oldClass {
	  constructor(...args) {
	    super(...args);
	  }
	  _DrawTextLine(line, penY, scale) {
	    let penX = 0;
	    if (this._horizontalAlign === "center")
	      penX = (this._width - line.width * scale) / 2;
	    else if (this._horizontalAlign === "right")
	      penX = this._width - line.width * scale;
	
	    //ASHLEY HERE: fix for kerning
	    //VVVVVVVVVVV
	    
	    let lastfrag = null;
	    let totOffset = 0;
	    const offsetArr = [];
	    let key = "text";
	    if (line.fragments && line.fragments[0] && line.fragments[0].text === undefined) {
	      key = "chArr"
	    }
	
	    for (const frag of line.fragments) {
	      if (lastfrag) {
	        if (
	          !this._HasStyleTag(lastfrag.styles, "size") &&
	          !this._HasStyleTag(frag.styles, "size")
	        ) {
	          const addSeparate =
	            this._MeasureText(lastfrag[key], lastfrag.styles).width +
	            this._MeasureText(frag[key], frag.styles).width;
	          let addTogether;
	          if (key === "text") {
	          	addTogether = this._MeasureText(
	              lastfrag.text + frag.text,
	              frag.styles
	            ).width;
	          } else {
	          	addTogether = this._MeasureText(
	              [...lastfrag.chArr, ...frag.chArr],
	              frag.styles
	            ).width;
	          }
	          let offset = addTogether - addSeparate;
	          totOffset += offset;
	          offsetArr.push(offset);
	        }
	      }
	      lastfrag = frag;
	    }
	    if (this._horizontalAlign === "center")
		    penX -= scale * totOffset / 2;
	    else if (this._horizontalAlign === "right")
		    penX -= scale * totOffset;
	    lastfrag = null;
	    
	    //^^^^^^^^^^^
	    //ASHLEY HERE: fix for kerning
	
	    for (const frag of line.fragments) {
	      //ASHLEY HERE: fix for kerning
	      //VVVVVVVVVVV
	      
	      let offset = 0;
	      if (lastfrag && offsetArr.length > 0) {
	        offset = offsetArr.shift();
	      }
	      penX += scale * offset;
	      
	      //^^^^^^^^^^^
	      //ASHLEY HERE: fix for kerning
	
	      this._DrawTextFragment(frag, penX, penY, scale, line.height);
	      penX += frag.width * scale;
	
	      //ASHLEY HERE: fix for kerning
	      //VVVVVVVVVVV
	      
	      lastfrag = frag;
	      
	      //^^^^^^^^^^^
	      //ASHLEY HERE: fix for kerning
	    }
	  }
	  _DrawTextFragment(frag, penX, penY, scale, lineHeight) {
	    const textContext = this._textContext;
	    const lineFontScale = lineHeight / 16;
	    let fragWidth = frag.width * scale;
	    const fragHeight = frag.height * scale;
	    const fragFontScale = frag.height / 16;
	    const lineSpaceHeight = (EXTRA_LINE_HEIGHT + this._lineHeight) * scale;
	    const styles = frag.styles;
	    let text = frag.text === undefined? frag.chArr : frag.text.split('');
	    if (this._drawMaxCharCount !== -1) {
	      if (this._drawCharCount >= this._drawMaxCharCount) return;
	      if (this._drawCharCount + text.length > this._drawMaxCharCount) {
	        text = text.slice(0, this._drawMaxCharCount - this._drawCharCount);
	        fragWidth = this._MeasureText(text, styles).width * scale;
	      }
	      this._drawCharCount += text.length;
	    }
	    const backgroundStyle = this._GetStyleTag(styles, "background");
	    const hasUnderline = this._HasStyleTag(styles, "u");
	    const hasStrikethrough = this._HasStyleTag(styles, "s");
	    if (
	      ((C3.IsCharArrayAllWhitespace && C3.IsCharArrayAllWhitespace(text) || C3.IsStringAllWhitespace(text.join(""))) &&
	        !backgroundStyle &&
	        !hasUnderline &&
	        !hasStrikethrough) ||
	      this._HasStyleTag(styles, "hide")
	    )
	      return;
        text = text.join("");
	    const offsetXStyle = this._GetStyleTag(styles, "offsetx");
	    penX += offsetXStyle ? parseFloat(offsetXStyle.param) * scale : 0;
	    const offsetYStyle = this._GetStyleTag(styles, "offsety");
	    penY += offsetYStyle ? parseFloat(offsetYStyle.param) * scale : 0;
	
	    //ASHLEY HERE: Angle tag
	    //VVVVVVVVVVV
	    
	    const angleStyle = this._GetStyleTag(styles, "angle");
	    const angle = angleStyle
	      ? (parseFloat(angleStyle.param) * Math.PI) / 180
	      : 0;
	    textContext.translate(penX, penY);
	    textContext.rotate(angle);
	    textContext.translate(-penX, -penY);
	    
	    //^^^^^^^^^^^
	    //ASHLEY HERE: Angle tag
	
	    if (backgroundStyle) {
	      this._SetDrawCanvasColor(backgroundStyle.param);
	      textContext.fillRect(
	        penX,
	        penY - fragHeight,
	        fragWidth,
	        fragHeight + lineSpaceHeight
	      );
	    }
	    const colorStyle = this._GetStyleTag(styles, "color");
	    this._SetDrawCanvasColor(colorStyle ? colorStyle.param : this._colorStr);
	    const opacityStyle = this._GetStyleTag(styles, "opacity");
	    this._SetDrawCanvasOpacity(
	      opacityStyle ? parseFloat(opacityStyle.param) / 100 : 1
	    );
	    const lineThicknessStyle = this._GetStyleTag(styles, "linethickness");
	    const lineThicknessScale = lineThicknessStyle
	      ? parseFloat(lineThicknessStyle.param)
	      : 1;
	    const isStroke = this._HasStyleTag(styles, "stroke");
	    if (isStroke)
	      this._SetDrawCanvasLineWith(
	        fragFontScale *
	          0.5 *
	          lineThicknessScale *
	          this._scaleFactor *
	          this._zoom *
	          self.devicePixelRatio
	      );
	    this._SetDrawFontString(this._GetFontString(false, styles));
	    if (!isStroke) {
	      this._SetDrawCanvasLineWith(
	        fragFontScale *
	          1 *
	          lineThicknessScale *
	          this._scaleFactor *
	          this._zoom *
	          self.devicePixelRatio
	      );
	      const outlineStyle = this._GetStyleTag(styles, "outline");
	      if (outlineStyle) {
	        this._SetDrawCanvasColor(outlineStyle.param);
	        fillOrStrokeText(textContext, true, text, penX, penY, fragWidth);
	      }
	      
	      this._SetDrawCanvasLineWith(
	        fragFontScale *
	          0.5 *
	          lineThicknessScale *
	          this._scaleFactor *
	          this._zoom *
	          self.devicePixelRatio
	      );
	      
	    }
	    this._SetDrawCanvasColor(colorStyle ? colorStyle.param : this._colorStr);
	    if (hasUnderline)
	      fillOrStrokeRect(
	        textContext,
	        isStroke,
	        penX,
	        penY + scale * lineFontScale,
	        fragWidth,
	        scale * lineFontScale * lineThicknessScale
	      );
	    if (hasStrikethrough) {
	      const defaultStrikeY = penY - fragHeight / 4;
	      const defaultStrikeHeight = scale * fragFontScale;
	      const strikeYMid = defaultStrikeY + defaultStrikeHeight / 2;
	      textContext.fillRect(
	        penX,
	        strikeYMid - (defaultStrikeHeight * lineThicknessScale) / 2,
	        fragWidth,
	        defaultStrikeHeight * lineThicknessScale
	      );
	    }
	    
	    this._SetDrawFontString(this._GetFontString(false, styles));
	    fillOrStrokeText(textContext, isStroke, text, penX, penY, fragWidth);
	    
	    //ASHLEY HERE: Angle tag
	    //VVVVVVVVVVV
	    
	    textContext.translate(penX, penY);
	    textContext.rotate(-angle);
	    textContext.translate(-penX, -penY);
	    
	    //^^^^^^^^^^^
	    //ASHLEY HERE: Angle tag
	  }
	};
}